﻿default monster_scale = 6
init python:
    class monster:
        def __init__(self, name, info, front, back, health, damage, speed, moves = None):
            self.name = name
            self.info = info
            self.front = front
            self.back = back
            self.max_health = health
            self.health = health
            self.damage = damage
            self.speed = speed
            self.moves = moves or []

            self.experience = 0
            self.is_alive = True

    class monster_move:
        def __init__(self, name, info, icon):
            self.name = name
            self.info = info
            self.icon = icon

    class monster_player:
        def __init__(self, name, info, image, monsters = None):
            self.name = name
            self.info = info
            self.image = image

            self.monsters = monsters or []
            self.team = []
            self.current = None

            self.x = 0
            self.y = 0
        def summon(self):
            for i in self.monsters:
                if i.is_alive:
                    return i
            else:
                return False

        def add_to_team(self, monster):
            if len(self.team) > 4:
                return
            if monster in self.team:
                return
            self.team.append(monster)

        def remove_from_team(self, monster):
            self.team.remove(monster)

        def catch(self, monster):
            self.monsters.append(monster)

        def release(self, monster):
            self.monsters.append(remove)


    class monster_battle_class:
        def __init__(self, player, enemy):
            self.player = player
            self.enemy = enemy
            self.stage = "start"
        def start(self):
            self.stage = "enemy_summon"
            renpy.notify(1)
        def enemy_summon(self):
            monster = self.enemy.summon()
            if monster:
                self.enemy.current = monster
                self.stage = "player_summon"
        def player_summon(self, monster):
            self.player.current = monster
            self.stage = "playing"
        def compare_speed(self):
            if self.player.current.speed > self.enemy.current.speed:
                self.stage = "players_turn"
            else:
                self.stage = "enemies_turn"
        def enemies_action(self):
            self.player.current.health -= 5
            self.stage = "players_turn"
        def players_action(self, action):
            self.enemy.current.health -= 5
            self.stage = "enemies_turn"
            pass




        def deal_damage(self):
            damage = random.randint(1,10)
            self.player.current.health -= damage

init:
    image kithulu_front:
        Crop((0, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image kithulu_back:
        Crop((0, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image punchrat_front:
        Crop((32, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image punchrat_back:
        Crop((32, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image eyefly_front:
        Crop((64, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image eyefly_back:
        Crop((64, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image goolum_front:
        Crop((96, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image goolum_back:
        Crop((96, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image borny_front:
        Crop((128, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image borny_back:
        Crop((128, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image lil_black_ice_front:
        Crop((160, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image lil_black_ice_back:
        Crop((160, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image slime_front:
        Crop((160, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image slime_ice_back:
        Crop((160, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image dandy_lion_front:
        Crop((160, 96, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image dandy_lion_back:
        Crop((160, 128, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image vilish_front:
        Crop((0, 160, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image vilish_back:
        Crop((0, 192, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
init:
    image demon_fist:
        Crop((0, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image basic_attack:
        Crop((32, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image venomous_bite:
        Crop((64, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image bribe:
        Crop((96, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image flee:
        Crop((128, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image firewall:
        Crop((160, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image push:
        Crop((192, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
    image meteor:
        Crop((224, 224, 32, 32), "Monster Battle/sprites.png")
        zoom monster_scale/2 nearest True
init:
    image blonde:
        Crop((0, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image vi:
        Crop((32, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image barbara:
        Crop((64, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image yari:
        Crop((96, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image blonde_back:
        Crop((128, 0, 32, 64), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image frame_idle:
        Crop((0, 64, 16, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image frame_hover:
        Crop((0, 80, 16, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image mana_bar_full:
        Crop((16, 64, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image mana_bar_empty:
        Crop((16, 80, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image health_bar_full:
        Crop((64, 64, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image health_bar_empty:
        Crop((64, 80, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True

    image arrow:
        Crop((112, 64, 48, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True
    image summon_circle:
        Crop((128, 80, 32, 16), "Monster Battle/sprites.png")
        zoom monster_scale nearest True


transform character_slide(x, y):
    ease .2 yoffset y
    ease .4 xoffset x
transform summon_circle_animation():
    alpha 0
    pause .4
    ease .2 alpha 0
    ease .2 alpha 1
    ease .2 alpha 0
    ease .2 alpha 1
    ease .2 alpha 0
    ease .2 alpha 1
    ease .4 alpha 0
transform summon_animation():
    yzoom .01 alpha 0
    pause .8
    ease .4 yzoom 1 alpha 1

style monster_text:
    color "#230096"
style monster_frame:
    align (.5,.5) padding (20,20)
    background Frame("frame_idle", 32,32)
style monster_button:
    align (.5,.5) padding (20,20)
    background Frame("frame_idle", 32,32)
    hover_background Frame("frame_hover", 32,32)
screen monster_battle_choose(g):
    style_prefix "monster"
    frame:
        vbox:
            text "Choose your monster."
            hbox:
                for i in g.player.monsters:
                    if i.is_alive:
                        button:
                            add i.front
                            action Return(i)

screen monster_battle_intro(g):
    tag monster_battle
    frame:
        align .5,.3 padding 0,0 background None
        xfill True
        fixed:
            fit_first True
            align .5,.5
            add g.enemy.image:
                if g.enemy.current:
                    at character_slide(64*monster_scale, 0)
                else:
                    at character_slide(32*monster_scale, 0)
            if g.enemy.current:
                add "summon_circle" at summon_circle_animation:
                    align .5,1.0
                    offset 16*monster_scale, 16
                add g.enemy.current.front at summon_animation:
                    align .5,1.0
                    offset 16*monster_scale, 0
    frame:
        align .5,.7 padding 0,0 background None
        xfill True
        fixed:
            fit_first True
            align .5,.5
            add g.player.image + "_back":
                if g.player.current:
                    at character_slide(-64*monster_scale, 0)
                else:
                    at character_slide(-32*monster_scale, 0)
            if g.player.current:

                add "summon_circle" at summon_circle_animation:
                    align .5,1.0
                    offset -16*monster_scale, 16
                add g.player.current.back at summon_animation:
                    align .5,1.0
                    offset -16*monster_scale, 0


screen monster_battle_screen(g):
    tag monster_battle
    style_prefix "monster"

    frame:
        align .5,.3 padding 0,0 background None
        xfill True
        fixed:
            fit_first True
            align .5,.5
            add g.enemy.image:
                offset 64*monster_scale, 0
            if g.enemy.current:
                add g.enemy.current.front:
                    align .5,1.0
                    offset 16*monster_scale, 0
                fixed fit_first True:
                    align (0.5, 1.0) xoffset -140
                    use monster_battle_bars(g.enemy.current)
    frame:
        align .5,.7 padding 0,0 background None
        xfill True
        fixed:
            fit_first True
            align .5,.5
            add g.player.image + "_back":
                offset -64*monster_scale, 0
            if g.player.current:
                add g.player.current.back:
                    align .5,1.0
                    offset -16*monster_scale, 0
                fixed fit_first True:
                    align (0.5, 1.0) xoffset 140 at flip(-1)
                    use monster_battle_bars(g.player.current)

    if g.stage == "enemies_turn":
        timer 1 action Function(g.enemies_action)
    elif g.stage == "players_turn":
        frame:
            align .5,1.0
            vbox:
                text "Choose your action." align .5,0.5
                hbox:
                    align .5,0.5
                    for i in g.player.current.moves:
                        button:
                            add i.icon
                            action Function(g.players_action, i)


    vbox:
        button:
            text "damage"
            action Function(g.deal_damage)

transform flip(x = 1, y = 1):
    xzoom x, yzoom y
screen monster_battle_bars(m):
    fixed fit_first True:
        add "arrow"
        bar value m.health range m.max_health:
            xysize 48*monster_scale,16*monster_scale
            left_bar "health_bar_full" right_bar "health_bar_empty"
            right_gutter 11*monster_scale
        bar value m.health range m.max_health:
            xysize 48*monster_scale,16*monster_scale
            left_bar "mana_bar_full" right_bar "mana_bar_empty"
            right_gutter 7*monster_scale

#--------------------------------- Example
default basic_attack = monster_move(
    name = "Basic attack",
    info = "Your basic punches and kicks.",
    icon = "basic_attack",
    )
default demon_fist = monster_move(
    name = "Demon fist",
    info = "Drags you to the depths of hell.",
    icon = "demon_fist",
    )
default venomous_bite = monster_move(
    name = "Venomous bite",
    info = "Just one jab and you'll die, eventually.",
    icon = "venomous_bite",
    )
default bribe = monster_move(
    name = "Bribe bite",
    info = "The only way to get to the top.",
    icon = "bribe",
    )
default flee = monster_move(
    name = "Flee",
    info = "Run like the wind.",
    icon = "flee",
    )
default firewall = monster_move(
    name = "Firewall",
    info = "Cut off the way.",
    icon = "firewall",
    )
default push = monster_move(
    name = "Push",
    info = "Depends on the context.",
    icon = "push",
    )
default meteor = monster_move(
    name = "Meteor",
    info = "Chancy but devastates.",
    icon = "meteor",
    )


default kithulu = monster(
    name = "Kithulu",
    info = "None",
    front = "kithulu_front",
    back = "kithulu_back",
    health = 55, damage = 55, speed = 5,
    moves = [basic_attack, bribe, flee]
    )
default punchrat = monster(
    name = "Punch rat",
    info = "None",
    front = "punchrat_front",
    back = "punchrat_back",
    health = 55, damage = 55, speed = 5,
    moves = [basic_attack, push, flee]
    )
default vilish = monster(
    name = "Vilish",
    info = "None",
    front = "vilish_front",
    back = "vilish_back",
    health = 55, damage = 55, speed = 5,
    moves = [demon_fist, flee]
    )


define chat_down = Character(None, window_align = (.5,1.0), window_padding = (20,20), what_align = (0,0), window_background = Frame("frame_idle", 32,32), window_xysize = (600,200), what_color = "#230096")
define chat_up = Character(None, window_align = (.5,.0), window_padding = (20,20), what_align = (0,0), window_background = Frame("frame_idle", 32,32), window_xysize = (600,200), what_color = "#230096")

label monster_battle_example:
    default battle = monster_battle_class(
        monster_player("Blonde", "", "blonde", [punchrat, kithulu, vilish]),
        monster_player("Barbara", "", "barbara", [punchrat, kithulu, vilish]),
    )

    show screen monster_battle_intro(battle)
    $ battle.start()
    chat_down "Get ready.{w=2}{nw}"
    $ battle.enemy_summon()
    chat_up "Enemy summons. [battle.enemy.current.name]{w=2}{nw}"
    chat_down "Your turn.{w=2}{nw}"
    call screen monster_battle_choose(battle)
    $ battle.player_summon(_return)
    chat_down "You have summoned [_return.name]{w=2}{nw}"
    $ battle.compare_speed()
    call screen monster_battle_screen(battle)






